//+------------------------------------------------------------------+
//|                                                TesterCheckit.mq4 |
//|                               Copyright  2008, Yury V. Reshetov |
//|                                             http://bigforex.biz/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Yury V. Reshetov"
#property link      "http://bigforex.biz/"

//---- input parameters

extern double       tp = 50;
extern double       sl = 50;
extern double       lots = 1;
extern int          mn = 888;
static int          prevtime = 0;

int init() {
   prevtime = Time[0];  
   if (IsTesting()) {
      return(0);
   }

   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (Time[0] == prevtime) return(0);
   prevtime = Time[0];
   
//----
   int total = OrdersTotal();
   
   for(int i = total - 1; i >= 0; i--) {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == mn) {
           return(0);
       }
   }
   
   total = OrdersHistoryTotal();
   
   if ((total % 2) == 0) {
     OrderSend(Symbol(), OP_BUY, lots, Ask, 1, Bid - sl * Point, Bid + tp * Point, WindowExpertName(), mn, 0, Blue); 
   } else {
     OrderSend(Symbol(), OP_SELL, lots, Bid, 1, Ask + sl * Point, Ask - tp * Point, WindowExpertName(), mn, 0, Red); 
   }
   

//-- Exit --
   return(0);
}


int deinit() {
   int total = OrdersHistoryTotal();
   double spread = MarketInfo(Symbol(), MODE_SPREAD);
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
      int type = OrderType();
      datetime opentime = OrderOpenTime();
      datetime closetime = OrderCloseTime();
      double stoploss = OrderStopLoss();
      double takeprofit = OrderTakeProfit();
      int startbar = iBarShift(Symbol(), 0, opentime, false);     
      int stopbar = iBarShift(Symbol(), 0, closetime, false);  
      for (int n = stopbar; n <= startbar; n++) {
         int counter = 0;
         if (type == OP_BUY) {
            if (High[n] > (takeprofit - Point / 2.0)) {
               if (counter > 0) {
                  Print("Order ", i + 1, "    ", TimeToStr(Time[n],TIME_DATE|TIME_MINUTES)); 
               }
               counter++;
            } 
            if (Low[n] < (stoploss + Point / 2.0)) {
               if (counter > 0) {
                  Print("Order ", i + 1, "    ", TimeToStr(Time[n],TIME_DATE|TIME_MINUTES)); 
               }
               counter++;
            } 
         }  else {
            if (High[n] > (stoploss - Point * (spread - 0.5))) {
               if (counter > 0) {
                  Print("Order ", i + 1, "    ", TimeToStr(Time[n],TIME_DATE|TIME_MINUTES)); 
               }
               counter++;
            } 
            if (Low[n] < (takeprofit - Point * (spread + 0.5))) {
               if (counter > 0) {
                  Print("Order ", i + 1, "    ", TimeToStr(Time[n],TIME_DATE|TIME_MINUTES)); 
               }
               counter++;
            } 
         } 
      }    
   }
   return(0);
}


